/* File BRY_modMain_Im.c */
/*
 ##############################################################
 # (C) 2013 BAE SYSTEMS
 #
 # ECOA Chuckle Brothers Sample
 #
 # $Id: BRY_modMain_Im.c,v 1.2 2017/11/06 15:33:25 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE Systems (Operations)
 # Limited, Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE Systems (Operations) Limited,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes, 
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software is developed by BAE Systems (Operations)
 # Limited, Electronic Systems, and is the Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/

#include "BRY_modMain_Im.h"
#include <stdio.h>
#include <pthread.h>

static struct timespec ONESEC = { 1, 0 };

/* Runtime lifecycle API */
void BRY_modMain_Im__INITIALIZE__received
   (BRY_modMain_Im__context* context)
{
   /* User Code Here */
}

void BRY_modMain_Im__START__received
   (BRY_modMain_Im__context* context)
{
	ECOA__log msg;
	ECOA__boolean8 available;
	//
	msg.current_size = sprintf( msg.data, "\n\tBarry is ready" );
	BRY_modMain_Im_container__log_info( context, msg );
}

void BRY_modMain_Im__STOP__received
   (BRY_modMain_Im__context* context)
{
   /* User Code Here */
}

void BRY_modMain_Im__SHUTDOWN__received
   (BRY_modMain_Im__context* context)
{
   /* User Code Here */
}

void BRY_modMain_Im__toMe__received
   (BRY_modMain_Im__context* context,
    const ECOA__int32 item)
{
	ECOA__log msg;
	//
//	msg.current_size = sprintf( msg.data, "\n\tTo Me received" );
//	BRY_modMain_Im_container__log_info( context, msg );
	//
	// Wait a moment, then send toYou
	nanosleep( &ONESEC, NULL );
	BRY_modMain_Im_container__toYou__send( context, item );
	//
	msg.current_size = sprintf( msg.data, "\n\tTo You" );
	BRY_modMain_Im_container__log_info( context, msg );
}
